import { ElementRef, Renderer2 } from '@angular/core';
import { AbstractControl, AsyncValidator, AsyncValidatorFn, ControlValueAccessor, ValidationErrors } from '@angular/forms';
import { Observable } from 'rxjs/Observable';
export declare class FileInputAccessor implements ControlValueAccessor, AsyncValidator {
    private _renderer;
    private _elementRef;
    allowedExt: RegExp | string | string[];
    allowedTypes: RegExp | string | string[];
    size: number;
    withMeta: boolean;
    maxHeight: number;
    maxWidth: number;
    onChange: (_: any) => void;
    onTouched: () => void;
    validator: AsyncValidatorFn;
    constructor(_renderer: Renderer2, _elementRef: ElementRef);
    writeValue(value: any): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
    validate(c: AbstractControl): Observable<ValidationErrors | null> | Promise<ValidationErrors | null>;
    private generateAsyncValidator();
    private onChangeGenerator(fn);
    private generateRegExp(pattern);
    private generateFileMeta(f, fr);
    private setImage(f, fr);
    private setText(f, fr);
}
